% ConfigSiteSettings
%
% ConfigSiteSettings Properties:
%    created     
%    modified    
%    centerGears  - A list of gear algorithm names that are treated as center-pays for the purpose of the billing report
%    providers   
%    viewerApps   - A list of viewer app associations for files and container
%
% ConfigSiteSettings Methods:
%    toJson - Convert the object to a Map that can be encoded to json
%    struct - Convert the object to a struct
    classdef ConfigSiteSettings < flywheel.ModelBase
    % NOTE: This file is auto generated by the swagger code generator program.
    % Do not edit the file manually.
    properties (Constant)
        propertyMap = containers.Map({ 'created', 'modified', 'centerGears', 'providers', 'viewerApps' }, ...
            { 'created', 'modified', 'center_gears', 'providers', 'viewer_apps' });
    end
    properties(Dependent)
        created
        modified
        centerGears
        providers
        viewerApps
    end
    methods
        function obj = ConfigSiteSettings(varargin)
            obj@flywheel.ModelBase(flywheel.model.ConfigSiteSettings.propertyMap);

            % Allow empty object creation
            if length(varargin)
                p = inputParser;
                addParameter(p, 'created', []);
                addParameter(p, 'modified', []);
                addParameter(p, 'centerGears', []);
                addParameter(p, 'providers', []);
                addParameter(p, 'viewerApps', []);

                parse(p, varargin{:});

                if ~isempty(p.Results.created)
                    obj.props_('created') = p.Results.created;
                end
                if ~isempty(p.Results.modified)
                    obj.props_('modified') = p.Results.modified;
                end
                if ~isempty(p.Results.centerGears)
                    obj.props_('center_gears') = p.Results.centerGears;
                end
                if ~isempty(p.Results.providers)
                    obj.props_('providers') = p.Results.providers;
                end
                if ~isempty(p.Results.viewerApps)
                    obj.props_('viewer_apps') = p.Results.viewerApps;
                end
            end
        end
        function result = get.created(obj)
            if ismethod(obj, 'get_created')
                result = obj.get_created();
            else
                if isKey(obj.props_, 'created')
                    result = obj.props_('created');
                else
                    result = [];
                end
            end
        end
        function obj = set.created(obj, value)
            obj.props_('created') = value;
        end
        function result = get.modified(obj)
            if ismethod(obj, 'get_modified')
                result = obj.get_modified();
            else
                if isKey(obj.props_, 'modified')
                    result = obj.props_('modified');
                else
                    result = [];
                end
            end
        end
        function obj = set.modified(obj, value)
            obj.props_('modified') = value;
        end
        function result = get.centerGears(obj)
            if ismethod(obj, 'get_centerGears')
                result = obj.get_centerGears();
            else
                if isKey(obj.props_, 'center_gears')
                    result = obj.props_('center_gears');
                else
                    result = [];
                end
            end
        end
        function obj = set.centerGears(obj, value)
            obj.props_('center_gears') = value;
        end
        function result = get.providers(obj)
            if ismethod(obj, 'get_providers')
                result = obj.get_providers();
            else
                if isKey(obj.props_, 'providers')
                    result = obj.props_('providers');
                else
                    result = [];
                end
            end
        end
        function obj = set.providers(obj, value)
            obj.props_('providers') = value;
        end
        function result = get.viewerApps(obj)
            if ismethod(obj, 'get_viewerApps')
                result = obj.get_viewerApps();
            else
                if isKey(obj.props_, 'viewer_apps')
                    result = obj.props_('viewer_apps');
                else
                    result = [];
                end
            end
        end
        function obj = set.viewerApps(obj, value)
            obj.props_('viewer_apps') = value;
        end
        function result = toJson(obj)
            result = containers.Map;
            if isKey(obj.props_, 'created')
                result('created') = flywheel.ModelBase.serializeValue(obj.props_('created'), 'char');
            end
            if isKey(obj.props_, 'modified')
                result('modified') = flywheel.ModelBase.serializeValue(obj.props_('modified'), 'char');
            end
            if isKey(obj.props_, 'center_gears')
                result('center_gears') = flywheel.ModelBase.serializeValue(obj.props_('center_gears'), 'vector[char]');
            end
            if isKey(obj.props_, 'providers')
                result('providers') = obj.props_('providers').toJson();
            end
            if isKey(obj.props_, 'viewer_apps')
                result('viewer_apps') = flywheel.ModelBase.cellmap(@toJson, obj.props_('viewer_apps'));
            end
        end
        function result = struct(obj)
            result = struct;

            if isKey(obj.props_, 'created')
                result.created = obj.props_('created');
            else
                result.created = [];
            end
            if isKey(obj.props_, 'modified')
                result.modified = obj.props_('modified');
            else
                result.modified = [];
            end
            if isKey(obj.props_, 'center_gears')
                result.centerGears = obj.props_('center_gears');
            else
                result.centerGears = [];
            end
            if isKey(obj.props_, 'providers')
                result.providers = struct(obj.props_('providers'));
            else
                result.providers = [];
            end
            if isKey(obj.props_, 'viewer_apps')
                result.viewerApps = flywheel.ModelBase.cellmap(@struct, obj.props_('viewer_apps'));
            else
                result.viewerApps = [];
            end
        end
        function result = returnValue(obj)
            result = obj;
        end
    end
    methods(Access = protected)
        function prpgrp = getPropertyGroups(obj)
            if ~isscalar(obj)
                prpgrp = getPropertyGroups@matlab.mixin.CustomDisplay(obj);
            else
                propList = struct;
                if isKey(obj.props_, 'created')
                    propList.created = obj.props_('created');
                else
                    propList.created = [];
                end
                if isKey(obj.props_, 'modified')
                    propList.modified = obj.props_('modified');
                else
                    propList.modified = [];
                end
                if isKey(obj.props_, 'center_gears')
                    propList.centerGears = obj.props_('center_gears');
                else
                    propList.centerGears = [];
                end
                if isKey(obj.props_, 'providers')
                    propList.providers = obj.props_('providers');
                else
                    propList.providers = [];
                end
                if isKey(obj.props_, 'viewer_apps')
                    propList.viewerApps = obj.props_('viewer_apps');
                else
                    propList.viewerApps = [];
                end
                prpgrp = matlab.mixin.util.PropertyGroup(propList);
            end
        end
    end
    methods(Static)
        function obj = fromJson(json, context)
            obj =  flywheel.model.ConfigSiteSettings;
            if isfield(json, 'created')
                obj.props_('created') = flywheel.ModelBase.deserializeValue(json.created, 'char');
            end
            if isfield(json, 'modified')
                obj.props_('modified') = flywheel.ModelBase.deserializeValue(json.modified, 'char');
            end
            if isfield(json, 'center_gears')
                obj.props_('center_gears') = flywheel.ModelBase.deserializeValue(json.center_gears, 'vector[char]');
            end
            if isfield(json, 'providers')
                obj.props_('providers') = flywheel.model.ProviderLinks.fromJson(json.providers, context);
            end
            if isfield(json, 'viewer_apps')
                obj.props_('viewer_apps') = flywheel.ModelBase.cellmap(@(x) flywheel.model.ViewerApp.fromJson(x, context), json.viewer_apps);
            end
            if isprop(obj, 'context_')
                obj.setContext_(context);
            end
        end
        function obj = ensureIsInstance(obj)
            if ~isempty(obj)
                % Realistically, we only convert structs
                if ~isa(obj, 'flywheel.model.ConfigSiteSettings')
                    obj = flywheel.model.ConfigSiteSettings(obj);
                end
                if isKey(obj.props_, 'created')
                end
                if isKey(obj.props_, 'modified')
                end
                if isKey(obj.props_, 'center_gears')
                end
                if isKey(obj.props_, 'providers')
                    obj.props_('providers') =  flywheel.model.ProviderLinks.ensureIsInstance(obj.props_('providers'));
                end
                if isKey(obj.props_, 'viewer_apps')
                    obj.props_('viewer_apps') = flywheel.ModelBase.cellmap(@flywheel.model.ViewerApp.ensureIsInstance, obj.props_('viewer_apps'));
                end
            end
        end
    end
end
