% ContainerParents
%
% ContainerParents Properties:
%    analysis     - Unique database ID
%    acquisition  - Unique database ID
%    session      - Unique database ID
%    subject      - Unique database ID
%    project      - Unique database ID
%    group        - Unique database ID
%
% ContainerParents Methods:
%    toJson - Convert the object to a Map that can be encoded to json
%    struct - Convert the object to a struct
    classdef ContainerParents < flywheel.ModelBase
    % NOTE: This file is auto generated by the swagger code generator program.
    % Do not edit the file manually.
    properties (Constant)
        propertyMap = containers.Map({ 'analysis', 'acquisition', 'session', 'subject', 'project', 'group' }, ...
            { 'analysis', 'acquisition', 'session', 'subject', 'project', 'group' });
    end
    properties(Dependent)
        analysis
        acquisition
        session
        subject
        project
        group
    end
    methods
        function obj = ContainerParents(varargin)
            obj@flywheel.ModelBase(flywheel.model.ContainerParents.propertyMap);

            % Allow empty object creation
            if length(varargin)
                p = inputParser;
                addParameter(p, 'analysis', []);
                addParameter(p, 'acquisition', []);
                addParameter(p, 'session', []);
                addParameter(p, 'subject', []);
                addParameter(p, 'project', []);
                addParameter(p, 'group', []);

                parse(p, varargin{:});

                if ~isempty(p.Results.analysis)
                    obj.props_('analysis') = p.Results.analysis;
                end
                if ~isempty(p.Results.acquisition)
                    obj.props_('acquisition') = p.Results.acquisition;
                end
                if ~isempty(p.Results.session)
                    obj.props_('session') = p.Results.session;
                end
                if ~isempty(p.Results.subject)
                    obj.props_('subject') = p.Results.subject;
                end
                if ~isempty(p.Results.project)
                    obj.props_('project') = p.Results.project;
                end
                if ~isempty(p.Results.group)
                    obj.props_('group') = p.Results.group;
                end
            end
        end
        function result = get.analysis(obj)
            if ismethod(obj, 'get_analysis')
                result = obj.get_analysis();
            else
                if isKey(obj.props_, 'analysis')
                    result = obj.props_('analysis');
                else
                    result = [];
                end
            end
        end
        function obj = set.analysis(obj, value)
            obj.props_('analysis') = value;
        end
        function result = get.acquisition(obj)
            if ismethod(obj, 'get_acquisition')
                result = obj.get_acquisition();
            else
                if isKey(obj.props_, 'acquisition')
                    result = obj.props_('acquisition');
                else
                    result = [];
                end
            end
        end
        function obj = set.acquisition(obj, value)
            obj.props_('acquisition') = value;
        end
        function result = get.session(obj)
            if ismethod(obj, 'get_session')
                result = obj.get_session();
            else
                if isKey(obj.props_, 'session')
                    result = obj.props_('session');
                else
                    result = [];
                end
            end
        end
        function obj = set.session(obj, value)
            obj.props_('session') = value;
        end
        function result = get.subject(obj)
            if ismethod(obj, 'get_subject')
                result = obj.get_subject();
            else
                if isKey(obj.props_, 'subject')
                    result = obj.props_('subject');
                else
                    result = [];
                end
            end
        end
        function obj = set.subject(obj, value)
            obj.props_('subject') = value;
        end
        function result = get.project(obj)
            if ismethod(obj, 'get_project')
                result = obj.get_project();
            else
                if isKey(obj.props_, 'project')
                    result = obj.props_('project');
                else
                    result = [];
                end
            end
        end
        function obj = set.project(obj, value)
            obj.props_('project') = value;
        end
        function result = get.group(obj)
            if ismethod(obj, 'get_group')
                result = obj.get_group();
            else
                if isKey(obj.props_, 'group')
                    result = obj.props_('group');
                else
                    result = [];
                end
            end
        end
        function obj = set.group(obj, value)
            obj.props_('group') = value;
        end
        function result = toJson(obj)
            result = containers.Map;
            if isKey(obj.props_, 'analysis')
                result('analysis') = flywheel.ModelBase.serializeValue(obj.props_('analysis'), 'char');
            end
            if isKey(obj.props_, 'acquisition')
                result('acquisition') = flywheel.ModelBase.serializeValue(obj.props_('acquisition'), 'char');
            end
            if isKey(obj.props_, 'session')
                result('session') = flywheel.ModelBase.serializeValue(obj.props_('session'), 'char');
            end
            if isKey(obj.props_, 'subject')
                result('subject') = flywheel.ModelBase.serializeValue(obj.props_('subject'), 'char');
            end
            if isKey(obj.props_, 'project')
                result('project') = flywheel.ModelBase.serializeValue(obj.props_('project'), 'char');
            end
            if isKey(obj.props_, 'group')
                result('group') = flywheel.ModelBase.serializeValue(obj.props_('group'), 'char');
            end
        end
        function result = struct(obj)
            result = struct;

            if isKey(obj.props_, 'analysis')
                result.analysis = obj.props_('analysis');
            else
                result.analysis = [];
            end
            if isKey(obj.props_, 'acquisition')
                result.acquisition = obj.props_('acquisition');
            else
                result.acquisition = [];
            end
            if isKey(obj.props_, 'session')
                result.session = obj.props_('session');
            else
                result.session = [];
            end
            if isKey(obj.props_, 'subject')
                result.subject = obj.props_('subject');
            else
                result.subject = [];
            end
            if isKey(obj.props_, 'project')
                result.project = obj.props_('project');
            else
                result.project = [];
            end
            if isKey(obj.props_, 'group')
                result.group = obj.props_('group');
            else
                result.group = [];
            end
        end
        function result = returnValue(obj)
            result = obj;
        end
    end
    methods(Access = protected)
        function prpgrp = getPropertyGroups(obj)
            if ~isscalar(obj)
                prpgrp = getPropertyGroups@matlab.mixin.CustomDisplay(obj);
            else
                propList = struct;
                if isKey(obj.props_, 'analysis')
                    propList.analysis = obj.props_('analysis');
                else
                    propList.analysis = [];
                end
                if isKey(obj.props_, 'acquisition')
                    propList.acquisition = obj.props_('acquisition');
                else
                    propList.acquisition = [];
                end
                if isKey(obj.props_, 'session')
                    propList.session = obj.props_('session');
                else
                    propList.session = [];
                end
                if isKey(obj.props_, 'subject')
                    propList.subject = obj.props_('subject');
                else
                    propList.subject = [];
                end
                if isKey(obj.props_, 'project')
                    propList.project = obj.props_('project');
                else
                    propList.project = [];
                end
                if isKey(obj.props_, 'group')
                    propList.group = obj.props_('group');
                else
                    propList.group = [];
                end
                prpgrp = matlab.mixin.util.PropertyGroup(propList);
            end
        end
    end
    methods(Static)
        function obj = fromJson(json, context)
            obj =  flywheel.model.ContainerParents;
            if isfield(json, 'analysis')
                obj.props_('analysis') = flywheel.ModelBase.deserializeValue(json.analysis, 'char');
            end
            if isfield(json, 'acquisition')
                obj.props_('acquisition') = flywheel.ModelBase.deserializeValue(json.acquisition, 'char');
            end
            if isfield(json, 'session')
                obj.props_('session') = flywheel.ModelBase.deserializeValue(json.session, 'char');
            end
            if isfield(json, 'subject')
                obj.props_('subject') = flywheel.ModelBase.deserializeValue(json.subject, 'char');
            end
            if isfield(json, 'project')
                obj.props_('project') = flywheel.ModelBase.deserializeValue(json.project, 'char');
            end
            if isfield(json, 'group')
                obj.props_('group') = flywheel.ModelBase.deserializeValue(json.group, 'char');
            end
            if isprop(obj, 'context_')
                obj.setContext_(context);
            end
        end
        function obj = ensureIsInstance(obj)
            if ~isempty(obj)
                % Realistically, we only convert structs
                if ~isa(obj, 'flywheel.model.ContainerParents')
                    obj = flywheel.model.ContainerParents(obj);
                end
                if isKey(obj.props_, 'analysis')
                end
                if isKey(obj.props_, 'acquisition')
                end
                if isKey(obj.props_, 'session')
                end
                if isKey(obj.props_, 'subject')
                end
                if isKey(obj.props_, 'project')
                end
                if isKey(obj.props_, 'group')
                end
            end
        end
    end
end
