% GearDoc - A full gear description, including manifest and exchange information
%
% GearDoc Properties:
%    id             - Unique database ID
%    category       - The gear category
%    gear          
%    exchange      
%    created        - Creation time (automatically set)
%    modified       - Last modification time (automatically updated)
%
% GearDoc Methods:
%    toJson - Convert the object to a Map that can be encoded to json
%    struct - Convert the object to a struct
    classdef GearDoc < flywheel.ModelBase & flywheel.mixins.GearMixin
    % NOTE: This file is auto generated by the swagger code generator program.
    % Do not edit the file manually.
    properties (Constant)
        propertyMap = containers.Map({ 'id', 'category', 'gear', 'exchange', 'created', 'modified' }, ...
            { '_id', 'category', 'gear', 'exchange', 'created', 'modified' });
    end
    properties(Dependent)
        id
        category
        gear
        exchange
        created
        modified
    end
    methods
        function obj = GearDoc(varargin)
            obj@flywheel.ModelBase(flywheel.model.GearDoc.propertyMap);

            % Allow empty object creation
            if length(varargin)
                p = inputParser;
                addParameter(p, 'id', []);
                addParameter(p, 'category', []);
                addParameter(p, 'gear', []);
                addParameter(p, 'exchange', []);
                addParameter(p, 'created', []);
                addParameter(p, 'modified', []);

                parse(p, varargin{:});

                if ~isempty(p.Results.id)
                    obj.props_('_id') = p.Results.id;
                end
                if ~isempty(p.Results.category)
                    obj.props_('category') = p.Results.category;
                end
                if ~isempty(p.Results.gear)
                    obj.props_('gear') = p.Results.gear;
                end
                if ~isempty(p.Results.exchange)
                    obj.props_('exchange') = p.Results.exchange;
                end
                if ~isempty(p.Results.created)
                    obj.props_('created') = p.Results.created;
                end
                if ~isempty(p.Results.modified)
                    obj.props_('modified') = p.Results.modified;
                end
            end
        end
        function result = get.id(obj)
            if ismethod(obj, 'get_id')
                result = obj.get_id();
            else
                if isKey(obj.props_, '_id')
                    result = obj.props_('_id');
                else
                    result = [];
                end
            end
        end
        function obj = set.id(obj, value)
            obj.props_('_id') = value;
        end
        function result = get.category(obj)
            if ismethod(obj, 'get_category')
                result = obj.get_category();
            else
                if isKey(obj.props_, 'category')
                    result = obj.props_('category');
                else
                    result = [];
                end
            end
        end
        function obj = set.category(obj, value)
            obj.props_('category') = value;
        end
        function result = get.gear(obj)
            if ismethod(obj, 'get_gear')
                result = obj.get_gear();
            else
                if isKey(obj.props_, 'gear')
                    result = obj.props_('gear');
                else
                    result = [];
                end
            end
        end
        function obj = set.gear(obj, value)
            obj.props_('gear') = value;
        end
        function result = get.exchange(obj)
            if ismethod(obj, 'get_exchange')
                result = obj.get_exchange();
            else
                if isKey(obj.props_, 'exchange')
                    result = obj.props_('exchange');
                else
                    result = [];
                end
            end
        end
        function obj = set.exchange(obj, value)
            obj.props_('exchange') = value;
        end
        function result = get.created(obj)
            if ismethod(obj, 'get_created')
                result = obj.get_created();
            else
                if isKey(obj.props_, 'created')
                    result = obj.props_('created');
                else
                    result = [];
                end
            end
        end
        function obj = set.created(obj, value)
            obj.props_('created') = value;
        end
        function result = get.modified(obj)
            if ismethod(obj, 'get_modified')
                result = obj.get_modified();
            else
                if isKey(obj.props_, 'modified')
                    result = obj.props_('modified');
                else
                    result = [];
                end
            end
        end
        function obj = set.modified(obj, value)
            obj.props_('modified') = value;
        end
        function result = toJson(obj)
            result = containers.Map;
            if isKey(obj.props_, '_id')
                result('_id') = flywheel.ModelBase.serializeValue(obj.props_('_id'), 'char');
            end
            if isKey(obj.props_, 'category')
                result('category') = flywheel.ModelBase.serializeValue(obj.props_('category'), 'char');
            end
            if isKey(obj.props_, 'gear')
                result('gear') = obj.props_('gear').toJson();
            end
            if isKey(obj.props_, 'exchange')
                result('exchange') = obj.props_('exchange').toJson();
            end
            if isKey(obj.props_, 'created')
                result('created') = flywheel.ModelBase.serializeValue(obj.props_('created'), 'datetime');
            end
            if isKey(obj.props_, 'modified')
                result('modified') = flywheel.ModelBase.serializeValue(obj.props_('modified'), 'datetime');
            end
        end
        function result = struct(obj)
            result = struct;

            if isKey(obj.props_, '_id')
                result.id = obj.props_('_id');
            else
                result.id = [];
            end
            if isKey(obj.props_, 'category')
                result.category = obj.props_('category');
            else
                result.category = [];
            end
            if isKey(obj.props_, 'gear')
                result.gear = struct(obj.props_('gear'));
            else
                result.gear = [];
            end
            if isKey(obj.props_, 'exchange')
                result.exchange = struct(obj.props_('exchange'));
            else
                result.exchange = [];
            end
            if isKey(obj.props_, 'created')
                result.created = obj.props_('created');
            else
                result.created = [];
            end
            if isKey(obj.props_, 'modified')
                result.modified = obj.props_('modified');
            else
                result.modified = [];
            end
        end
        function result = returnValue(obj)
            result = obj;
        end
    end
    methods(Access = protected)
        function prpgrp = getPropertyGroups(obj)
            if ~isscalar(obj)
                prpgrp = getPropertyGroups@matlab.mixin.CustomDisplay(obj);
            else
                propList = struct;
                if isKey(obj.props_, '_id')
                    propList.id = obj.props_('_id');
                else
                    propList.id = [];
                end
                if isKey(obj.props_, 'category')
                    propList.category = obj.props_('category');
                else
                    propList.category = [];
                end
                if isKey(obj.props_, 'gear')
                    propList.gear = obj.props_('gear');
                else
                    propList.gear = [];
                end
                if isKey(obj.props_, 'exchange')
                    propList.exchange = obj.props_('exchange');
                else
                    propList.exchange = [];
                end
                if isKey(obj.props_, 'created')
                    propList.created = obj.props_('created');
                else
                    propList.created = [];
                end
                if isKey(obj.props_, 'modified')
                    propList.modified = obj.props_('modified');
                else
                    propList.modified = [];
                end
                prpgrp = matlab.mixin.util.PropertyGroup(propList);
            end
        end
    end
    methods(Static)
        function obj = fromJson(json, context)
            obj =  flywheel.model.GearDoc;
            if isfield(json, 'x0x5Fid')
                obj.props_('_id') = flywheel.ModelBase.deserializeValue(json.x0x5Fid, 'char');
            end
            if isfield(json, 'category')
                obj.props_('category') = flywheel.ModelBase.deserializeValue(json.category, 'char');
            end
            if isfield(json, 'gear')
                obj.props_('gear') = flywheel.model.Gear.fromJson(json.gear, context);
            end
            if isfield(json, 'exchange')
                obj.props_('exchange') = flywheel.model.GearExchange.fromJson(json.exchange, context);
            end
            if isfield(json, 'created')
                obj.props_('created') = flywheel.ModelBase.deserializeValue(json.created, 'datetime');
            end
            if isfield(json, 'modified')
                obj.props_('modified') = flywheel.ModelBase.deserializeValue(json.modified, 'datetime');
            end
            if isprop(obj, 'context_')
                obj.setContext_(context);
            end
        end
        function obj = ensureIsInstance(obj)
            if ~isempty(obj)
                % Realistically, we only convert structs
                if ~isa(obj, 'flywheel.model.GearDoc')
                    obj = flywheel.model.GearDoc(obj);
                end
                if isKey(obj.props_, '_id')
                end
                if isKey(obj.props_, 'category')
                end
                if isKey(obj.props_, 'gear')
                    obj.props_('gear') =  flywheel.model.Gear.ensureIsInstance(obj.props_('gear'));
                end
                if isKey(obj.props_, 'exchange')
                    obj.props_('exchange') =  flywheel.model.GearExchange.ensureIsInstance(obj.props_('exchange'));
                end
                if isKey(obj.props_, 'created')
                end
                if isKey(obj.props_, 'modified')
                end
            end
        end
    end
end
