% JobCompletionTicket - A ticket for uploading files and completing a job
%
% JobCompletionTicket Properties:
%    ticket  - The ticket to use to perform file uploads to a job
%
% JobCompletionTicket Methods:
%    toJson - Convert the object to a Map that can be encoded to json
%    struct - Convert the object to a struct
    classdef JobCompletionTicket < flywheel.ModelBase
    % NOTE: This file is auto generated by the swagger code generator program.
    % Do not edit the file manually.
    properties (Constant)
        propertyMap = containers.Map({ 'ticket' }, ...
            { 'ticket' });
    end
    properties(Dependent)
        ticket
    end
    methods
        function obj = JobCompletionTicket(varargin)
            obj@flywheel.ModelBase(flywheel.model.JobCompletionTicket.propertyMap);

            % Allow empty object creation
            if length(varargin)
                p = inputParser;
                addParameter(p, 'ticket', []);

                parse(p, varargin{:});

                if ~isempty(p.Results.ticket)
                    obj.props_('ticket') = p.Results.ticket;
                end
            end
        end
        function result = get.ticket(obj)
            if ismethod(obj, 'get_ticket')
                result = obj.get_ticket();
            else
                if isKey(obj.props_, 'ticket')
                    result = obj.props_('ticket');
                else
                    result = [];
                end
            end
        end
        function obj = set.ticket(obj, value)
            obj.props_('ticket') = value;
        end
        function result = toJson(obj)
            result = containers.Map;
            if isKey(obj.props_, 'ticket')
                result('ticket') = flywheel.ModelBase.serializeValue(obj.props_('ticket'), 'char');
            end
        end
        function result = struct(obj)
            result = struct;

            if isKey(obj.props_, 'ticket')
                result.ticket = obj.props_('ticket');
            else
                result.ticket = [];
            end
        end
        function result = returnValue(obj)
            result = obj;
        end
    end
    methods(Access = protected)
        function prpgrp = getPropertyGroups(obj)
            if ~isscalar(obj)
                prpgrp = getPropertyGroups@matlab.mixin.CustomDisplay(obj);
            else
                propList = struct;
                if isKey(obj.props_, 'ticket')
                    propList.ticket = obj.props_('ticket');
                else
                    propList.ticket = [];
                end
                prpgrp = matlab.mixin.util.PropertyGroup(propList);
            end
        end
    end
    methods(Static)
        function obj = fromJson(json, context)
            obj =  flywheel.model.JobCompletionTicket;
            if isfield(json, 'ticket')
                obj.props_('ticket') = flywheel.ModelBase.deserializeValue(json.ticket, 'char');
            end
            if isprop(obj, 'context_')
                obj.setContext_(context);
            end
        end
        function obj = ensureIsInstance(obj)
            if ~isempty(obj)
                % Realistically, we only convert structs
                if ~isa(obj, 'flywheel.model.JobCompletionTicket')
                    obj = flywheel.model.JobCompletionTicket(obj);
                end
                if isKey(obj.props_, 'ticket')
                end
            end
        end
    end
end
