% JobLog
%
% JobLog Properties:
%    id    - Unique database ID
%    logs 
%
% JobLog Methods:
%    toJson - Convert the object to a Map that can be encoded to json
%    struct - Convert the object to a struct
    classdef JobLog < flywheel.ModelBase
    % NOTE: This file is auto generated by the swagger code generator program.
    % Do not edit the file manually.
    properties (Constant)
        propertyMap = containers.Map({ 'id', 'logs' }, ...
            { 'id', 'logs' });
    end
    properties(Dependent)
        id
        logs
    end
    methods
        function obj = JobLog(varargin)
            obj@flywheel.ModelBase(flywheel.model.JobLog.propertyMap);

            % Allow empty object creation
            if length(varargin)
                p = inputParser;
                addParameter(p, 'id', []);
                addParameter(p, 'logs', []);

                parse(p, varargin{:});

                if ~isempty(p.Results.id)
                    obj.props_('id') = p.Results.id;
                end
                if ~isempty(p.Results.logs)
                    obj.props_('logs') = p.Results.logs;
                end
            end
        end
        function result = get.id(obj)
            if ismethod(obj, 'get_id')
                result = obj.get_id();
            else
                if isKey(obj.props_, 'id')
                    result = obj.props_('id');
                else
                    result = [];
                end
            end
        end
        function obj = set.id(obj, value)
            obj.props_('id') = value;
        end
        function result = get.logs(obj)
            if ismethod(obj, 'get_logs')
                result = obj.get_logs();
            else
                if isKey(obj.props_, 'logs')
                    result = obj.props_('logs');
                else
                    result = [];
                end
            end
        end
        function obj = set.logs(obj, value)
            obj.props_('logs') = value;
        end
        function result = toJson(obj)
            result = containers.Map;
            if isKey(obj.props_, 'id')
                result('id') = flywheel.ModelBase.serializeValue(obj.props_('id'), 'char');
            end
            if isKey(obj.props_, 'logs')
                result('logs') = flywheel.ModelBase.cellmap(@toJson, obj.props_('logs'));
            end
        end
        function result = struct(obj)
            result = struct;

            if isKey(obj.props_, 'id')
                result.id = obj.props_('id');
            else
                result.id = [];
            end
            if isKey(obj.props_, 'logs')
                result.logs = flywheel.ModelBase.cellmap(@struct, obj.props_('logs'));
            else
                result.logs = [];
            end
        end
        function result = returnValue(obj)
            result = obj;
        end
    end
    methods(Access = protected)
        function prpgrp = getPropertyGroups(obj)
            if ~isscalar(obj)
                prpgrp = getPropertyGroups@matlab.mixin.CustomDisplay(obj);
            else
                propList = struct;
                if isKey(obj.props_, 'id')
                    propList.id = obj.props_('id');
                else
                    propList.id = [];
                end
                if isKey(obj.props_, 'logs')
                    propList.logs = obj.props_('logs');
                else
                    propList.logs = [];
                end
                prpgrp = matlab.mixin.util.PropertyGroup(propList);
            end
        end
    end
    methods(Static)
        function obj = fromJson(json, context)
            obj =  flywheel.model.JobLog;
            if isfield(json, 'id')
                obj.props_('id') = flywheel.ModelBase.deserializeValue(json.id, 'char');
            end
            if isfield(json, 'logs')
                obj.props_('logs') = flywheel.ModelBase.cellmap(@(x) flywheel.model.JobLogStatement.fromJson(x, context), json.logs);
            end
            if isprop(obj, 'context_')
                obj.setContext_(context);
            end
        end
        function obj = ensureIsInstance(obj)
            if ~isempty(obj)
                % Realistically, we only convert structs
                if ~isa(obj, 'flywheel.model.JobLog')
                    obj = flywheel.model.JobLog(obj);
                end
                if isKey(obj.props_, 'id')
                end
                if isKey(obj.props_, 'logs')
                    obj.props_('logs') = flywheel.ModelBase.cellmap(@flywheel.model.JobLogStatement.ensureIsInstance, obj.props_('logs'));
                end
            end
        end
    end
end
