% SearchSuggestion
%
% SearchSuggestion Properties:
%    display  - The display value of the suggestion
%    value    - The value to use for replacement
%
% SearchSuggestion Methods:
%    toJson - Convert the object to a Map that can be encoded to json
%    struct - Convert the object to a struct
    classdef SearchSuggestion < flywheel.ModelBase
    % NOTE: This file is auto generated by the swagger code generator program.
    % Do not edit the file manually.
    properties (Constant)
        propertyMap = containers.Map({ 'display', 'value' }, ...
            { 'display', 'value' });
    end
    properties(Dependent)
        display
        value
    end
    methods
        function obj = SearchSuggestion(varargin)
            obj@flywheel.ModelBase(flywheel.model.SearchSuggestion.propertyMap);

            % Allow empty object creation
            if length(varargin)
                p = inputParser;
                addParameter(p, 'display', []);
                addParameter(p, 'value', []);

                parse(p, varargin{:});

                if ~isempty(p.Results.display)
                    obj.props_('display') = p.Results.display;
                end
                if ~isempty(p.Results.value)
                    obj.props_('value') = p.Results.value;
                end
            end
        end
        function result = get.display(obj)
            if ismethod(obj, 'get_display')
                result = obj.get_display();
            else
                if isKey(obj.props_, 'display')
                    result = obj.props_('display');
                else
                    result = [];
                end
            end
        end
        function obj = set.display(obj, value)
            obj.props_('display') = value;
        end
        function result = get.value(obj)
            if ismethod(obj, 'get_value')
                result = obj.get_value();
            else
                if isKey(obj.props_, 'value')
                    result = obj.props_('value');
                else
                    result = [];
                end
            end
        end
        function obj = set.value(obj, value)
            obj.props_('value') = value;
        end
        function result = toJson(obj)
            result = containers.Map;
            if isKey(obj.props_, 'display')
                result('display') = flywheel.ModelBase.serializeValue(obj.props_('display'), 'char');
            end
            if isKey(obj.props_, 'value')
                result('value') = flywheel.ModelBase.serializeValue(obj.props_('value'), 'char');
            end
        end
        function result = struct(obj)
            result = struct;

            if isKey(obj.props_, 'display')
                result.display = obj.props_('display');
            else
                result.display = [];
            end
            if isKey(obj.props_, 'value')
                result.value = obj.props_('value');
            else
                result.value = [];
            end
        end
        function result = returnValue(obj)
            result = obj;
        end
    end
    methods(Access = protected)
        function prpgrp = getPropertyGroups(obj)
            if ~isscalar(obj)
                prpgrp = getPropertyGroups@matlab.mixin.CustomDisplay(obj);
            else
                propList = struct;
                if isKey(obj.props_, 'display')
                    propList.display = obj.props_('display');
                else
                    propList.display = [];
                end
                if isKey(obj.props_, 'value')
                    propList.value = obj.props_('value');
                else
                    propList.value = [];
                end
                prpgrp = matlab.mixin.util.PropertyGroup(propList);
            end
        end
    end
    methods(Static)
        function obj = fromJson(json, context)
            obj =  flywheel.model.SearchSuggestion;
            if isfield(json, 'display')
                obj.props_('display') = flywheel.ModelBase.deserializeValue(json.display, 'char');
            end
            if isfield(json, 'value')
                obj.props_('value') = flywheel.ModelBase.deserializeValue(json.value, 'char');
            end
            if isprop(obj, 'context_')
                obj.setContext_(context);
            end
        end
        function obj = ensureIsInstance(obj)
            if ~isempty(obj)
                % Realistically, we only convert structs
                if ~isa(obj, 'flywheel.model.SearchSuggestion')
                    obj = flywheel.model.SearchSuggestion(obj);
                end
                if isKey(obj.props_, 'display')
                end
                if isKey(obj.props_, 'value')
                end
            end
        end
    end
end
